# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

import json
import os
import glob
from PyQt5.QtCore import Qt
from PyQt5.QtWidgets import QListWidgetItem, QFileDialog


def createNewProject_(self, config):
    self.projectName = QFileDialog.getSaveFileName(
        self, 'New Project', 'NewProject', 'Project Files (*.arcproj)')
    if self.projectName[0] == '': return
    config['projectRoot'] = os.path.dirname(self.projectName[0]) + '/'
    with open(self.projectName[0], 'w') as f:
            json.dump(self.config, f, indent=4)
    # ウィンドウのタイトルをプロジェクト名に
    name = self.projectName
    name = os.path.basename(name[0])
    name, ext = os.path.splitext(name)
    self.setWindowTitle(name + '   AR Calibration')


class ProjectFile:
    def __init__(self, config):
        print('init')

    def createNewProject(self, config):
        createNewProject_(self, config=config)

    def openJson(self, config):

        # エクスプローラーを開いてjsonファイルを選択
        self.projectName = QFileDialog.getOpenFileName(
            self, 'Open Project', os.getcwd(), 'Project (*.arcproj)')
        if self.projectName[0] == '': return
        f = open(self.projectName[0], 'r')
        json_data = json.load(f)

        def openImage(self, config):
            # 画像の取得
            self.dirName = json_data['projectRoot']
            print(self.dirName)
            self.cap_dir = './' + os.path.relpath(self.dirName) + '/'
            pngFiles = glob.glob(self.cap_dir + '/*.' + 'png')
            jpgFiles = glob.glob(self.cap_dir + '/*.' + 'jpg')
            bmpFiles = glob.glob(self.cap_dir + '/*.' + 'bmp')
            self.Files = pngFiles + jpgFiles + bmpFiles
            sorted(self.Files)

            # ファイルリストのクリア
            self.FileList.clear()
            # ファイルリストに追加
            for i, file in enumerate(self.Files):
                item = QListWidgetItem(os.path.basename(file))
                # チェック状態を反映
                if json_data['captureList'][i][1] is True:
                    item.setCheckState(Qt.Checked)
                else:
                    item.setCheckState(Qt.Unchecked)
                self.FileList.addItem(item)

            # 表示する最初の画像
            if self.FileList.item(0) is not None:
                self.dirName = self.FileList.item(0).text()

            # capture画像を表示
            self.loadImages(self.config['projectRoot']+'capture/')

        openImage(self, config=config)

    def saveJson(self, config):
        # プロジェクトが無ければ作る
        if hasattr(self, 'projectName') is False:
            createNewProject_(self, config=config)

        if hasattr(self, 'fileName'):
            with open(self.projectName[0], 'w') as f:
                json.dump(self.config, f, indent=4)

    def test():
        print('test')
