# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

import subprocess


def detectAR(self, mode):
    if mode not in ['cam', 'proj']:
        return -1

    indir = self.config['projectRoot']+'iso/'
    outdir = self.config['projectRoot']+mode+'/'

    outdir_point = outdir+'point/'
    if mode == 'cam':
        base_img = indir+'Camera%03d.png'
        detected_img = outdir+'detect_AR_image/detect_cam%03d.png'
    elif mode == 'proj':
        base_img = indir+'Projector%03d.png'
        detected_img = outdir+'detect_AR_image/detect_proj%03d.png'

    exe = []
    exe.append('exe\\detect_AR_cam.exe')
    exe.append(self.config['Projection_img_name'])
    exe.append(base_img.replace('/', '\\'))
    exe.append('0')
    exe.append(str(len(self.config['captureList'])))
    exe.append(str(self.config[mode]['AR_thresh']))
    exe.append(str(self.config[mode]['thresh_first']))
    exe.append('1')
    exe.append(str(self.config[mode]['thresh_interval']))
    exe.append(str(self.config[mode]['thresh_repeat_num']))
    exe.append('63')
    exe.append(str(self.config[mode]['MARK_SIZE']))
    exe.append(str(self.config[mode]['MARK_SPACE_X']))
    exe.append(str(self.config[mode]['MARK_SPACE_Y']))
    exe.append(str(self.config[mode]['use_center']))
    exe.append(str(self.config[mode]['boad_rotation']))
    exe.append(str(self.config[mode]['calib_mode']))
    exe.append(str(self.config[mode]['Minimum_number']))
    exe.append(outdir_point.replace('/', '\\'))
    exe.append(detected_img.replace('/', '\\'))
    print(' '.join(exe))

    result = subprocess.call(exe)

    return result
