# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

import subprocess


def extrinsicCV2I3D(self):
    target_dir = self.config['projectRoot']+'param/'
    input_dir = self.config['projectRoot']+'proj/param/'

    openCVR = input_dir+'camprojR.txt'
    openCVT = input_dir+'camprojt.txt'

    Rigidtrans = target_dir+'rigidtrans.txt'
    Invi3dRigid = target_dir+'iprojtocam.txt'
    i3dRigid = target_dir+'projtocam.txt'

    ocvr = open(openCVR, 'r')
    ocvt = open(openCVT, 'r')
    rigid = open(Rigidtrans, 'w')

    line_r = ocvr.read()
    Data_r = line_r.split()
    line_t = ocvt.read()
    Data_t = line_t.split()

    for i in range(3):
        buf = [Data_r[i*3], Data_r[i*3+1], Data_r[i*3+2], Data_t[i]]
        print(' '.join(buf))
        rigid.write(' '.join(buf) + '\n')

    print('0 0 0 1')
    rigid.write('0 0 0 1')

    ocvr.close()
    ocvt.close()
    rigid.close()

    exe = ['exe\\posecalc.exe', '-i tm:{}'.format(Rigidtrans.replace('/', '\\')), '-o {}'.format(Invi3dRigid.replace('/', '\\'))]
    print(' '.join(exe))
    subprocess.call(' '.join(exe), shell=True)

    invi3d = open(Invi3dRigid, 'r')
    i3d = open(i3dRigid, 'w')

    line_i = invi3d.read()
    Data_i = line_i.split()

    buf = [Data_i[0], str(-1.0*float(Data_i[1])), str(-1.0*float(Data_i[2])), Data_i[3], str(-1.0*float(Data_i[4])), str(-1.0*float(Data_i[5]))]
    print(' '.join(buf))
    i3d.write(' '.join(buf) + '\n')

    invi3d.close()
    i3d.close()

    return 0
