# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

def intrinsicCV2I3D(self, mode):
    if mode == 'cam':
        intrinsic_opencv = self.config['projectRoot']+'cam/param/Cam_mat.txt'
        intrinsic_i3d = self.config['projectRoot']+'param/i3d_camparam.txt'
    elif mode == 'proj':
        intrinsic_opencv = self.config['projectRoot']+'proj/param/projMat.txt'
        intrinsic_i3d = self.config['projectRoot']+'param/i3d_projparam.txt'
    else:
        return -1

    width = self.config[mode]['width']
    height = self.config[mode]['height']
    pixcel_size = 0.02
    param_cv = open(intrinsic_opencv, 'r')
    param_i3d = open(intrinsic_i3d, 'w')

    line = param_cv.readline()
    print(line[:-1])
    itemList = line[:-1].split(' ')

    pixelsizeX = pixcel_size / width
    fX = float(itemList[0])
    fY = float(itemList[4])
    XYratio = fX / fY

    pixelsizeY = pixelsizeX * XYratio
    focus = float(itemList[0]) * pixelsizeX

    image_centerY = height - float(itemList[5])

    converted = []
    converted.append(str(focus))
    converted.append('0')
    converted.append(str(pixelsizeX))
    converted.append(str(pixelsizeY))
    converted.append(str(itemList[2]))
    converted.append(str(image_centerY))
    converted.append(str(width))
    converted.append(str(height))

    print('==> ', ' '.join(converted))
    param_i3d.write(' '.join(converted))

    param_cv.close()
    param_i3d.close()

    return 0
