# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

import subprocess


def selfCalib(self, mode):
    if mode not in ['cam', 'proj']:
        return -1

    target_dir = self.config['projectRoot']+mode+'/'
    if mode == 'cam':
        base_img = self.config['projectRoot']+'iso/Camera%03d.png'
        point2dname = target_dir+'point/cam2D%03d.txt'
        point3dname = target_dir+'point/cam3D%03d.txt'
    elif mode == 'proj':
        base_img = self.config['projectRoot']+'iso/Projector%03d.png'
        point2dname = target_dir+'point/proj2D%03d.txt'
        point3dname = target_dir+'point/pattern%03d.txt'

    validID = self.config['projectRoot']+'validID.txt'

    paramdir = target_dir+'param/'
    reprojdir = target_dir+'reproj/'

    exe = []
    exe.append('exe\\camera_calib_method.exe')
    exe.append(base_img.replace('/', '\\'))
    exe.append(point2dname.replace('/', '\\'))
    exe.append(point3dname.replace('/', '\\'))
    exe.append(validID.replace('/', '\\'))
    exe.append(str(self.config[mode]['distflag']))
    exe.append(paramdir.replace('/', '\\'))
    exe.append(reprojdir.replace('/', '\\'))
    print(' '.join(exe))

    result = subprocess.call(exe)

    return result
