# -*- coding: utf-8 -*-

# Kyushu University
# Developed by Hitoshi Teshima and Akihiko Sayo
# Ver 0.1.0
# 2019/09/23 All Right Reserved Kawasaki Lab.

import cv2
import numpy as np


def undistPoint(self, mode):
    if mode == 'cam':
        param_dir = self.config['projectRoot']+'cam/'
        A = np.loadtxt(param_dir+'param/Cam_mat.txt').reshape(3, 3)
        dist = np.loadtxt(param_dir+'param/dist.txt')
    elif mode == 'proj':
        param_dir = self.config['projectRoot']+'proj/'
        A = np.loadtxt(param_dir+'param/ProjMat.txt').reshape(3, 3)
        dist = np.loadtxt(param_dir+'param/projdist.txt')

    validID = np.loadtxt(self.config['projectRoot']+'validID.txt', dtype=int)

    for i in validID:
        pt2D = np.loadtxt(param_dir+'point/{0}2D{1:03d}.txt'.format(mode, i))
        pt2D_out = cv2.undistortPoints(pt2D.reshape(pt2D.shape[0], 1, 2), A, dist, P=A)
        np.savetxt(param_dir+'point_ud/{0}2D{1:03d}.txt'.format(mode, i), pt2D_out.reshape(pt2D_out.shape[0], 2), fmt='%.3f')

    return 0
